package imageopstest;

import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.PixelWriter;
import javafx.scene.paint.Color;
import javafx.scene.transform.Affine;
import javafx.scene.transform.NonInvertibleTransformException;
import javafx.stage.Stage;

public class Ebene extends Application {

    PixelWriter pixelWriter;

    private final int hoehe = 768;
    private final int breite = 1024;
    private final int rand = 0;

    // Image Data
//    private static final int IMAGE_WIDTH = 10;
//    private static final int IMAGE_HEIGHT = 10;
//    private byte imageData[]
//            = new byte[IMAGE_WIDTH * IMAGE_HEIGHT * 3];
    // Drawing Surface (Canvas)
    private GraphicsContext gc;
    private Canvas canvas;
    private Group root;

    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage primaryStage) {
        primaryStage.setTitle("Einige 2D-Objekte");
        root = new Group();
        canvas = new Canvas(breite - rand, hoehe - rand);
        //canvas.setTranslateX(100);
        //canvas.setTranslateY(100);
        gc = canvas.getGraphicsContext2D();
        gc.setTransform(this.affineAbbildung(breite, hoehe));
//        pixelWriter = gc.getPixelWriter();
        root.getChildren().add(canvas);
//        this.drawFeigenbaum(primaryStage);

        this.zeichneElemente(gc);

        primaryStage.setScene(new Scene(root, breite, hoehe));
        primaryStage.show();
//        this.drawFeigenbaum(primaryStage);

    }

    private void zeichneElemente(GraphicsContext gc) {
        Dreieck tria = new Dreieck(
                new Punkt(10, 10),
                new Punkt(100, 100),
                new Punkt(10, 50),
                Color.RED);
        tria.zeichnen(gc);
        tria.drehen(0.50);
        tria.zeichnen(gc);
        tria.setFarbe(Color.BLUE);
        tria.drehen(0.50);
        tria.zeichnen(gc);

    }

    Affine affineAbbildung(int breite, int hoehe) {
        Affine affine = new Affine();
        affine.appendTranslation(breite/2,hoehe/2);
        affine.appendScale(1.0,-1.0);
        return affine;
    }

}
